<?php
$core->addBehavior('publicHeadContent',array('RandomImages','lightbox'));

class RandomImages
{
    public static function lightbox(&$core)
    {
        // Si le plugin lightbox est install + activ ajoute du javascript d
        // dans l'entte pour le support de ce dernier
        if (!$core->blog->settings->lightbox_enabled)
            return;

        $url = $core->blog->getQmarkURL().'pf=lightbox';
        echo
        '<script type="text/javascript">'."\n".
        "//<![CDATA[\n".
        '$(function() {'."\n".
            'var lb_settings = {'."\n".
                "loader_img : '".html::escapeJS($url)."/img/loader.gif',\n".
                "prev_img   : '".html::escapeJS($url)."/img/prev.png',\n".
                "next_img   : '".html::escapeJS($url)."/img/next.png',\n".
                "close_img  : '".html::escapeJS($url)."/img/close.png',\n".
                "blank_img  : '".html::escapeJS($url)."/img/blank.gif'\n".
            "};".
            '$("div.imghasard").each(function() {'."\n".
                    '$(this).find("a[href$=.jpg],a[href$=.jpeg],a[href$=.png],a[href$=.gif],'.
                    'a[href$=.JPG],a[href$=.JPEG],a[href$=.PNG],a[href$=.GIF]").modalImages(lb_settings);'."\n".

            "})\n".
        "});\n".
        "\n//]]>\n".
        "</script>\n";
    }


    public static function myWidget(&$w)
    {
        global $core;

        function exploration($parentdir,$extbig,$racinedir) {
            $dhdir = opendir($racinedir.$parentdir);
            if (!isset($files))
                $files = array();
            if ($dhdir!=False) {
                while (false !== ($subdir = readdir($dhdir)))  {
                    $dir = $parentdir.'/'.$subdir;
                    if (is_dir($racinedir.$dir) & $subdir != '.' & $subdir != '..')    {
                        //C'est un dossier, rappel de la fonction
                        $files += exploration($parentdir.'/'.$subdir,$extbig,$racinedir);
                    } elseif ($subdir{0} != "." & in_array(strrchr($subdir,'.'),$extbig)) {
                        //pour les images qui se trouve directement dans le dossier principal
                        $files[] = $parentdir.'/'.$subdir;
                    }
                }
            }
            return $files;
        }

        if (isset($_SERVER['DOCUMENT_ROOT_HASH']))
            $racinedir = $_SERVER['DOCUMENT_ROOT_HASH'].'/';
        else
            $racinedir = $_SERVER['DOCUMENT_ROOT'].'/';
        $files = array();

        $format = $w->format;
        $openWith = $w->openWith;

        switch($format) {
            case 1:
                $ext = "_sq.jpg";
                break;
            case 2:
                $ext = "_t.jpg";
                break;
            case 3:
                $ext = "_s.jpg";
                break;
            case 4:
                $ext = "_m.jpg";
                break;
            case 5:
                $ext = "";
                $openWith = False;
            }
        $extbig = array(".jpg", ".png", ".jpeg", ".gif",".JPG", ".PNG", ".JPEG", ".GIF",);


        switch($openWith) {
            case 1: //normal
            case 3: //lightbox
                $link = '<a href="%orig%" title="%titre%"><img src="%min%" alt="'.__('image').'" /></a>';
                break;
            case 2: //popup
                $link = '<a href="%orig%" onclick="window.open(this.href, \'%titre%\', \'resizable=yes, width=%X% ,height=%Y, location=no, menubar=no, status=no\'); return false;" title="%titre%" ><img src="%min%" alt="'.__('image').'" /></a>';
                break;
            default : //pas de lien (taille original)
                $link = '<img src="%orig%" alt="'.__('image').'" />';
                break;
            }


        $basedir = $w->imagedir;
        if ($basedir{0} == '/')
            $basedir = substr($basedir,1);
        $files = exploration($basedir,$extbig,$racinedir);

        $titre = html::escapeHTML($w->title);

        $chaine = '
            <div class="imghasard">
            <h2>'.$titre.'</h2><p>';

        //Boucle pour afficher plusieurs images
        $nofindimg = 0;

        shuffle($files);
        $nb = 0;
        foreach ($files as $imgbig) {
            if ($nb == $w->nbre)
                break;

            if ($format == 5) {
                $img = $imgbig;
            } else {
                $img = str_replace($extbig,$ext,$imgbig);   //cration du chemin de la miniature
                $p = strrpos($img,"/")+1;
                $img = substr($img,0,$p).'.'.substr($img,$p);
            }

            $reso = getimagesize($racinedir.$imgbig);
            //Si la miniature existe
            if (is_file($racinedir.$img)) {
                //Cration du lien
                $chaine .= str_replace(array('%min%','%orig%','%titre%','%X%','%Y'),array('/'.$img,'/'.$imgbig,$titre,($reso[0]+20),($reso[1])+20),$link);
                $nb ++;
            } else {
                //dsincrmentation de nombre, incrmentation des imges non trouves
                $nofindimg++;
            }
        }

        if ($nb == 0)
            $chaine .= '<p>'.__('Error! No picture was found.').'</p>
                            <ul>
                                <li>'.__('Make sure you set the correct directory (plugin seeks').'
                                <a href="/'.$basedir.'">'.__('here').'</a>).</li>
                                <li>'.__('Have you explored this directory with the media manager of dotclear for to create miniatures ?').'</li>
                                <li>'.__('Have you ever a problem? Ask me').'
                                <a href="http://forum.jonas.tuxfamily.org/">'.__('here').'</a>.</li>
                            <ul>';

        $chaine .= '</p></div>';

        if ($w->homepage && $core->url->type != 'default') {
                            return;
                    }
        else {
            return $chaine;
                }
    }
}
?>
